routes/web.php
<?php

use Illuminate\Support\Facades\Route;

use App\Http\Controllers\CompaniesController;
use App\Http\Controllers\EmployeesController;
use App\Http\Controllers\AuthController;
use App\Http\Controllers\ItemsController;
use App\Http\Controllers\SellController;
use App\Http\Controllers\SellSummaryController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('lang/{lang}', ['as' => 'lang.switch', 'uses' => 'App\Http\Controllers\LanguageController@switchLang']);

Auth::routes(['register' => false, 'reset' => false]);

Route::group(['middleware' => 'auth', 'checktoken'], function () {
    Route::get('/', [CompaniesController::class, 'index']); 
    Route::get('home', [CompaniesController::class, 'index']); 

    Route::get('/data-companies', [CompaniesController::class, 'dataCompanies']);

    Route::resource('companies', CompaniesController::class);

    Route::get('company/destroy/{id}', [CompaniesController::class, 'destroy']);


    Route::get('/data-employees', [EmployeesController::class, 'dataEmployees']);

    Route::resource('employees', EmployeesController::class);

    Route::get('employee/destroy/{id}', [EmployeesController::class, 'destroy']);


    Route::resource('items', ItemsController::class);

    Route::get('item/destroy/{id}', [ItemsController::class, 'destroy']);


    Route::resource('sell', SellController::class);

    Route::get('sell/destroy/{id}', [SellController::class, 'destroy']);

    Route::get('store-item-price/{id}', [SellController::class, 'storeItemPrice']);

    Route::resource('sell-summary', SellSummaryController::class);
});

app/Models/Sell.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use App\Models\Items;
use App\Models\Employees;

class Sell extends Model
{
    use HasFactory;

    public $timestamps = false;

    protected $table = "sell";
    protected $primaryKey = 'id';

    protected $fillable = [
        'created_date',
        'item',
        'price',
        'discount',
        'employee'
    ];

    public function hasItem()
    {
        return $this->belongsTo(Items::class, 'item', 'id');
    }

    public function hasEmployee()
    {
        return $this->belongsTo(Employees::class, 'employee', 'id');
    }
}

app/Http/Controllers/SellController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Sell;
use App\Models\SellSummary;
use App\Models\Items;
use App\Models\Employees;
use App\Models\Timezone;
use Carbon\Carbon;
use DB;
use Yajra\Datatables\Datatables;
use App\Http\Requests\StoreSellRequest;
use Illuminate\Support\Facades\Redirect;
use App\Http\Traits\SellSummaryTrait;
use App\Http\Traits\TimezoneTrait;
use App\Http\Traits\SellTrait;

class SellController extends Controller
{
    use SellSummaryTrait;
    use TimezoneTrait;
    use SellTrait;
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        if (!empty($request->timezone)) {
            $this->setTimezone($request->timezone);
        }

        $timezones = Timezone::Orderby('offset')->get();

        if($request->ajax()){
            $sell_datatable = $this->setSellTable();

            return $sell_datatable;
        }
        return view('sell.sell-index', compact('timezones'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $items = Items::pluck('name', 'id');
        $employees = Employees::Orderby('first_name')->get();
        return view('sell.sell-create', compact('items', 'employees'));
    }

    public function storeItemPrice($id)
    {
        $item = Items::where('id', $id)->first();
    
        return response()->json($item);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreSellRequest $request)
    {
        $new_sell = $this->createSell($request);

        $check_sell_summary = SellSummary::isSellSummaryExist($new_sell->created_date, $new_sell->employee);

        if ($check_sell_summary == true) {
            $this->updateSellSummary($new_sell);
        }
        else{
            $this->storeSellSummary($new_sell);
        }

        return redirect()->route('sell.show', ['sell' => $new_sell])->with('success', 'null');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $sell = Sell::where('id', $id)->first();
        $date = Carbon::parse($sell->created_at)->format('d m Y');

        return view('sell.sell-detail', compact('sell', 'date'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Sell $sell)
    {
        $items = Items::pluck('name', 'id');
        $employees = Employees::Orderby('first_name')->get();
        return view('sell.sell-edit', compact('sell', 'items', 'employees'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(StoreSellRequest $request, $id)
    {
        $old_sell = Sell::find($id);
        $old_price      =   $old_sell->price;
        $old_discount   =   $old_sell->discount;
        $old_employee   =   $old_sell->employee;

        $updated_sell = Sell::find($id);
        $updated_sell->item = $request->item;
        $updated_sell->price = $request->price;
        $updated_sell->discount = $request->discount;
        $updated_sell->employee = $request->employee;
        $updated_sell->save();

        $created_date = Carbon::createFromFormat('Y-m-d H:i:s', $updated_sell->created_date);

        $check_sell_summary = SellSummary::isSellSummaryExist($created_date, $updated_sell->employee);

        if($check_sell_summary == true){
            $this->storeSellSummarybyUpdate(2, $updated_sell, $old_price, $old_discount, $old_employee);
        }
        else{
            $this->storeSellSummarybyUpdate(1, $updated_sell, $old_price, $old_discount, $old_employee);
        }

        return redirect()->route('sell.show', ['sell' => $updated_sell])->with('success', 'null');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $data = Sell::findOrFail($id);
        $this->updateSellSummarybyDelete($data);
        $data->delete();

        return redirect()->route('sell.index');
    }
}

resources/views/sell/sell-create.blade.php
<!-- <link href="{{ asset('css/style.css') }}" rel="stylesheet"> -->
@extends('adminlte::page')

@section('title', trans('text.AddSell'))

@section('content_header')
    <h1>{{ trans('text.AddSell') }}</h1>
@stop

@section('content')
    <html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <div class="container">
    <div class="row background">
        <div class="container">
            <div class="row">
                <div class="col-md-12">
                    <form method="post" action="{{ route('sell.store')}}" enctype="multipart/form-data">
                        {{csrf_field()}}
                        <div class="row mt-2">
                            <div class="col-md-2 text-left card-caption-home">{{ trans('text.ItemName') }} : </div>
                            <div class="col-md-8">
                                <select name="item" id="item" class="form-control">
                                    <option value="">{{ trans('text.Items List') }}</option>
                                    @foreach ($items as $id => $name)
                                        <option value="{{ $id }}">{{ $name }}</option>
                                    @endforeach
                                </select>
                            </div>
                        </div>
                        
                        <div class="row mt-2">
                            <div class="col-md-2 text-left card-caption-home">{{ trans('text.Price') }} : </div>
                            <div class="col-md-8">
                                <input class="form-control" type="text" name="price" id="price" />
                            </div>
                        </div>
                        
                        <div class="row mt-2">
                            <div class="col-md-2 text-left card-caption-home">{{ trans('text.Discount') }} : </div>
                            <div class="col-md-8">
                                <input class="form-control" type="text" name="discount" />
                            </div>
                        </div>

                        <div class="row mt-2">
                            <div class="col-md-2 text-left card-caption-home">{{ trans('text.Employee') }} : </div>
                            <div class="col-md-8">
                                <select name="employee" id="employee" class="form-control">
                                    <option value="">{{ trans('text.Employees List') }}</option>
                                    @foreach ($employees as $employee)
                                        <option value="{{ $employee->id }}">{{ $employee->first_name }} {{ $employee->last_name }}</option>
                                    @endforeach
                                </select>
                            </div>
                        </div>

                        <div class="row mt-2">
                            <div class="col-md-2 text-left"></div>
                            <div class="col-md-8">
                                <button type="submit" class="btn btn-success" style="margin-top:12px"><i class="glyphicon glyphicon-check"></i>{{ trans('text.Add') }}</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

@stop


@section('js')
    <script> console.log('Hi!'); </script>
    <script>
        $(function () {
            $('#item').on('change', function () {
                var id = $(this).val();
                $.ajax({
                    url: "/store-item-price/"+id,
                    // data: {id: $(this).val()},
                    success: function (response) {
                        $('#price').val(response.price);
                    }
                })
            });
        });
    </script>
@stop

resources/views/sell/sell-detail.blade.php
@extends('adminlte::page')

@section('title', trans('text.SellDetail'))

@section('content_header')
    <h1>{{ trans('text.SellDetail') }}</h1>
@stop

@section('content')<!doctype html>
    <html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <a href="/sell/{{$sell->id}}/edit" class="btn btn-primary"><i class="fa fa-edit"></i> {{ trans('text.Edit') }}</a>
    <button class="btn btn-danger" data-toggle="modal" data-target="#Modal"><i class="fa fa-trash"></i> {{ trans('text.Delete') }}</button>
    <div class="modal fade" id="Modal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true" align="left">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="sub-title" id="exampleModalLabel">{{ trans('text.Confirmation') }}</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    {{ trans('text.deleteConf') }}
                </div>
                <div class="modal-footer">
                    <a href="{{ URL('/sell/destroy/'.$sell->id) }}" type="button" class="btn btn-danger">OK</a>
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">{{ trans('text.Cancel') }}</button>
                </div>
            </div>
        </div>
    </div>

    <table style="width:100%">
        <tr>
            <th>{{ trans('text.ItemName') }}</th>
            <td>{{$sell->hasItem->name}}</td>
        </tr>
        <tr>
            <th>{{ trans('text.Price') }}</th>
            <td>@convert($sell->price)</td>
        </tr>
        <tr>
            <th>{{ trans('text.Discount') }}</th>
            <td>{{$sell->discount}}</td>
        </tr>
        <tr>
            <th>{{ trans('text.Employee') }}</th>
            <td>{{$sell->hasEmployee->first_name}} {{$sell->hasEmployee->last_name}}</td>
        </tr>
        <tr>
            <th>{{ trans('text.createdAt') }}</th>
            <td>{{ $date }}</td>
        </tr>
    </table>
@stop

@section('css')
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.25/css/dataTables.bootstrap4.min.css">
@stop

@section('js')
    <script> console.log('Hi!'); </script>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/1.10.25/js/jquery.dataTables.min.js"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/1.10.25/js/dataTables.bootstrap4.min.js"></script>
@stop

resources/views/sell/sell-edit.blade.php
<!-- <link href="{{ asset('css/style.css') }}" rel="stylesheet"> -->
@extends('adminlte::page')

@section('title', trans('text.EditSell'))

@section('content_header')
    <h1>{{ trans('text.EditSell') }}</h1>
@stop

@section('content')
    <html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <div class="container">
    <div class="row background">
        <div class="container">
            <div class="row">
                <div class="col-md-12">
                    <form method="post" action="{{ route('sell.update', $sell->id) }}" enctype="multipart/form-data">
                        {{csrf_field()}}
                        @method('PATCH')
                        <div class="row mt-2">
                            <div class="col-md-2 text-left card-caption-home">{{ trans('text.Item') }} : </div>
                            <div class="col-md-8">
                                <select name="item" id="item" class="form-control">
                                    <option value="">{{ trans('text.Items List') }}</option>
                                    @foreach ($items as $id => $name)
                                        @if($sell->item == $id)
                                            <option value="{{ $id }}" selected>{{ $name }}</option>
                                        @else
                                            <option value="{{ $id }}">{{ $name }}</option>
                                        @endif
                                    @endforeach
                                </select>
                            </div>
                        </div>
                        
                        <div class="row mt-2">
                            <div class="col-md-2 text-left card-caption-home">{{ trans('text.Price') }} : </div>
                            <div class="col-md-8">
                                <input class="form-control" type="text" name="price" id="price" value="{{ $sell->price }}"/>
                            </div>
                        </div>
                        
                        <div class="row mt-2">
                            <div class="col-md-2 text-left card-caption-home">{{ trans('text.Discount') }} : </div>
                            <div class="col-md-8">
                                <input class="form-control" type="text" name="discount" value="{{ $sell->discount }}"/>
                            </div>
                        </div>

                        <div class="row mt-2">
                            <div class="col-md-2 text-left card-caption-home">{{ trans('text.Employee') }} : </div>
                            <div class="col-md-8">
                                <select name="employee" id="employee" class="form-control">
                                    <option value="">{{ trans('text.Employees List') }}</option>
                                    @foreach ($employees as $employee)
                                        @if($sell->employee == $employee->id)
                                            <option value="{{ $employee->id }}" selected>{{ $employee->first_name }} {{ $employee->last_name }}</option>
                                        @else
                                            <option value="{{ $employee->id }}">{{ $employee->first_name }} {{ $employee->last_name }}</option>
                                        @endif
                                    @endforeach
                                </select>
                            </div>
                        </div>
                        <div class="row mt-2">
                            <div class="col-md-2 text-left"></div>
                            <div class="col-md-8">
                                <button type="submit" class="btn btn-success" style="margin-top:12px"><i class="glyphicon glyphicon-check"></i>{{ trans('text.Edit') }}</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

@stop


@section('js')
    <script> console.log('Hi!'); </script>
    <script>
        $(function () {
            $('#item').on('change', function () {
                var id = $(this).val();
                $.ajax({
                    url: "/store-item-price/"+id,
                    // data: {id: $(this).val()},
                    success: function (response) {
                        $('#price').val(response.price);
                    }
                })
            });
        });
    </script>
@stop

resources/views/sell/sell-index.blade.php
@extends('adminlte::page')

@section('title', trans('text.SellList'))

@section('content_header')
    <h1>{{ trans('text.SellList') }}</h1>
@stop

@section('content')<!doctype html>
    <html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <hr>
    <div class="container">
        <a href="{{ route('sell.create')}}" class="btn btn-success">{{ trans('text.Add') }} {{ trans('text.Sell') }}</a>
    </div>
    <br/>

    <div class="container">
        <div class="row">
            <div class="col-md-4">
                <select data-column="5" class="form-control filter-select" name="timezone" id="timezone">
                    <option value="">{{ trans('text.Timezone') }}...</option>
                    @foreach($timezones as $timezone)
                        @if(session::get('timezone_id') == $timezone->id)
                            <option value="{{ $timezone->id }}" selected>{{ $timezone->name }} ({{ $timezone->offset }})</option>
                        @else
                            <option value="{{ $timezone->id }}">{{ $timezone->name }} ({{ $timezone->offset }})</option>
                        @endif
                    @endforeach
                </select>
            </div>
            <div class="col-md-1">
                <button type="button" name="filter" id="filter" class="btn btn-primary">Filter</button>
            </div>
            <!-- <div class="col-md-1">
                <button type="button" name="refresh" id="refresh" class="btn btn-primary">Refresh</button>
            </div> -->
        </div>
        <table class="table table-bordered" id="items_table">
            <thead>
                <tr>
                    <th>No.</th>
                    <th>{{ trans('text.ItemName') }}</th>
                    <th>{{ trans('text.Price') }}</th>
                    <th>{{ trans('text.Discount') }}</th>
                    <th>{{ trans('text.createdAt') }}</th>
                    <th>{{ trans('text.Employee') }}</th>
                    <th width="20%">{{ trans('text.Action') }}</th>
                </tr>
            </thead>
            <tbody></tbody>
            <tfoot>
                <tr>
                    <td></td>
                    <td>
                        <input type="text" data-column="1" placeholder="{{ trans('text.ItemName') }}...." class="form-control filter-input">
                    </td>
                    <td>
                        <input type="text" data-column="2" placeholder="{{ trans('text.Price') }}...." class="form-control filter-input">
                    </td>
                    <td></td>
                    <td></td>
                    <td>
                        <input type="text" data-column="5" placeholder="{{ trans('text.Employee') }}...." class="form-control filter-input">
                    </td>
                    <td></td>
                </tr>
            </tfoot>
        </table>
    </div>

    <div id="confirmModal" class="modal fade" role="dialog">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h3 class="modal-title">{{ trans('text.Confirmation') }}</h3>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <p align="center" style="margin:0;">{{ trans('text.deleteConf') }}</p>
                </div>
                <div class="modal-footer">
                    <button type="button" name="ok_button" id="ok_button" class="btn btn-danger">OK</button>
                    <button type="button" class="btn btn-default" data-dismiss="modal">{{ trans('text.Cancel') }}</button>
                </div>
            </div>
        </div>
    </div>
@stop

@section('css')
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.25/css/dataTables.bootstrap4.min.css">
@stop

@section('js')
    <script> console.log('Hi!'); </script>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/1.10.25/js/jquery.dataTables.min.js"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/1.10.25/js/dataTables.bootstrap4.min.js"></script>
    <script>
        $(document).ready(function(){

            load_data();

            function load_data(timezone = ''){
                var t = $('#items_table').DataTable({
                    processing: true,
                    serverSide: true,
                    bLengthChange: false,
                    ajax: {
                        url: "{{ route('sell.index') }}",
                        data: {timezone:timezone}
                    },
                    columns: [
                        {
                            data: 'rownum',
                            name: 'rownum'
                        },
                        {
                            data: 'item',
                            name: 'hasItem.name'
                        },
                        {
                            data: 'price',
                            name: 'price'
                        },
                        {
                            data: 'discount',
                            name: 'discount',
                        },
                        {
                            data: 'created_date',
                            name: 'created_date',
                        },
                        {
                            data: 'employee',
                            name: function( data, type, full, meta ) {
                                return 'hasEmployee.first_name';
                            },
                        },
                        {
                            data: 'action',
                            name: 'action',
                            orderable: false
                        }
                    ],
                    "columnDefs": [ {
                        "searchable": false,
                        "orderable": false,
                        "targets": 0
                    } ],
                    "order": [[ 1, 'asc' ]]
                });

                $('.filter-input').keyup(function(){
                    t.column( $(this).data('column'))
                        .search($(this).val())
                        .draw();
                });

                t.on( 'order.dt search.dt', function () {
                    t.column(0, {search:'applied', order:'applied'}).nodes().each( function (cell, i) {
                        cell.innerHTML = i+1;
                    } );
                } ).draw();
            };

            $('#filter').click(function() {
                var timezone = $('#timezone').val();
                if(timezone != ''){
                    $('#items_table').DataTable().destroy();
                    load_data(timezone);
                };
            });

            var sell_id;

            $(document).on('click', '.delete', function(){
                sell_id = $(this).attr('id');
                $('#confirmModal').modal('show');
            });

            $('#ok_button').click(function(){
                $.ajax({
                    url:"sell/destroy/"+sell_id,
                    success:function(data) {
                        setTimeout(function(){
                            $('#confirmModal').modal('hide');
                            $('#items_table').DataTable().ajax.reload();
                            alert('Data Deleted');
                        }, 2000);
                    }
                })
            });
        });
    </script>
@stop